tmp<fv::convectionScheme<scalar> > mvConvection
(
    fv::convectionScheme<scalar>::New
    (
        mesh,
        fields,
        phi,
        mesh.divScheme("div(phi,Yj_h)")
    )
);

{
    reaction.correct();
    dQ = reaction.dQ();
    label explicitIndex = -1;
    volScalarField Yt(0.0*Y[0]);

    forAll(Y, j)
    {
        if (Y[j].name() != explicitSpecie)
        {
            volScalarField& Yj = Y[j];
            
            fvScalarMatrix YjEqn
            (
                fvm::ddt(rho, Yj)
              + mvConvection->fvmDiv(phi, Yj)
              - fvm::laplacian(turb.muEff(), Yj)
             ==
                reaction.R(Yj)
              + fvOptions(rho, Yj)
            );
            
            YjEqn.relax();

            fvOptions.constrain(YjEqn);

            // Applying adsorption mass correction term and solving
            volScalarField adsorptionMassSource = 0.0 * volAdsorptions[0];

            forAll(adsorbates, k)
            {
                if (Y[j].name() == adsorbates[k])
                {
                    adsorptionMassSource 
                   =
                    volAdsorptions[k];
                }
            }

            solve
            (
                YjEqn == adsorptionMassSource, 
                mesh.solver("Yj")
            );

            fvOptions.correct(Yj);
            Yj.max(0.0);
            Yt += Yj;
        }
        else
        {
            explicitIndex = j;
        }
    }
    Y[explicitIndex] = scalar(1) - Yt;
    Y[explicitIndex].max(0.0);
}