PtrList< PtrList<label> > fluidsSolidsPatchIDs(fluidRegions.size());
PtrList< PtrList<label> > fluidsSolidsAdsorptionTypes(fluidRegions.size());

forAll(fluidRegions, i)
{
    fluidsSolidsPatchIDs.set
    (
        i, 
        new PtrList<label>(solidRegions.size())
    );

    fluidsSolidsAdsorptionTypes.set
    (
        i, 
        new PtrList<label>(solidRegions.size())
    );

    PtrList<label>& fluidSolidsPatchIDs = fluidsSolidsPatchIDs[i];
    PtrList<label>& fluidSolidsAdsorptionTypes = fluidsSolidsAdsorptionTypes[i];

    forAll(solidRegions, j)
    {
        // Building adsorption patches look up table
        fluidSolidsPatchIDs.set
        (
            j, 
            new label 
            (
                fluidRegions[i].boundaryMesh().findPatchID
                (
                    fluidRegions[i].name() + "_to_" + solidRegions[j].name()
                )
            )
        );

        // Checking for adsorbent type
        const dictionary& subDict = adsorptionDict.subDict("regionAdsorbentTypes");
        word adsorbentType
        (
            subDict.lookupOrDefault<word>
            (
                fluidRegions[i].name() + "_to_" + solidRegions[j].name(),
                subDict.lookupOrDefault<word>
                (
                    solidRegions[j].name() + "_to_" + fluidRegions[i].name(), 
                    "noAdsorbent"
                )
            )
        );

        // Finding adsorbent type ID
        fluidSolidsAdsorptionTypes.set
        (
            j, 
            new label (-1)
        );

        // Building adsorption patches types look up table
        forAll(adsorbentTypes, k)
        {
            if (adsorbentTypes[k] == adsorbentType)
            {
                fluidSolidsAdsorptionTypes[j] = k;
            }
        }
    }
}