// Corrected density equation involving adsorption source-term
{
    fvScalarMatrix rhoEqn
    (
        fvm::ddt(rho)
      + fvc::div(phi)
      ==
        fvOptions(rho)
    );

    fvOptions.constrain(rhoEqn);

    // Applying adsorption mass correction term and solving
    volScalarField adsorptionMassSource = 0.0 * volAdsorptions[0];

    forAll(adsorbates, k)
    {
        adsorptionMassSource 
      +=
        volAdsorptions[k];
    }

    solve
    (
        rhoEqn == adsorptionMassSource, 
        mesh.solver("rho")
    ); 

    fvOptions.correct(rho);
}