// Calculating adsorption values
scalar counter = 0;
scalar totLoading = 0;
scalar totEqLoading = 0;
scalar totLoadingRate = 0;
scalar totAdsorptionArea = 0;


// AdsorptionRate = (K0 + K1*(qe - qc) + K2*(qe - qc)^2 + K3*(qe - qc)^3) * ((Cmax -qe)/Cmax)^n
dimensionedScalar n = adsorbentsNs[adsorbentTypeID][k];

// Maximum possible adsorption loading
dimensionedScalar Cmax = adsorbentsCmaxs[adsorbentTypeID][k];

// Zero order constant
dimensionedScalar K0 = adsorbentsK0s[adsorbentTypeID][k];

// First order constant
dimensionedScalar K1 = adsorbentsK1s[adsorbentTypeID][k];

// Second order constant
dimensionedScalar K2 = adsorbentsK2s[adsorbentTypeID][k];

// Third order constant
dimensionedScalar K3 = adsorbentsK3s[adsorbentTypeID][k];

// Equilibrium adsorption loading
dimensionedScalar Ke = adsorbentsKes[adsorbentTypeID][k];

// Adsorption enthalpy
dimensionedScalar adsorptionDeltaH = adsorptionDeltaHs[adsorbentTypeID][k];

// equilibriumConstantTemperatureDependency = Ke / pow(T, np) * exp(-activationEnergy / R / T)
dimensionedScalar np = adsorbentsNps[adsorbentTypeID][k];

// Activation energy
dimensionedScalar activationEnergy = adsorptionActivationEnergies[adsorbentTypeID][k];

// Gas constant
const dimensionedScalar R("R", dimensionSet(1, 2, -2, -1, -1, 0, 0), 8.314);


// Temporary variables
const scalarField& volume = mesh.V();
const fvPatchList& patches = mesh.boundary();   
const scalar& deltaT = runTime.deltaTValue();
const surfaceScalarField& area = mesh.magSf();
const fvPatch& currPatch = patches[fluidSolidPatchID];

volScalarField corrFact = 0.0 * adsorption;
volScalarField maxAvailable = 0.0 * adsorption;
volScalarField maxAdsorption = 0.0 * adsorption;