    fvMesh& mesh = fluidRegions[i];    

    combustionModels::psiCombustionModel& reaction = chemistryFluid[i];
    psiReactionThermo& thermo = chemistryFluid[i].thermo();

    thermo.validate(args.executable(), "h", "e");

    basicMultiComponentMixture& composition = thermo.composition();
    PtrList<volScalarField>& Y = composition.Y();

    word explicitSpecie(thermo.lookup("explicitSpecie"));

    volScalarField& rho = rhoFluid[i];
    volVectorField& U = UFluid[i];
    surfaceScalarField& phi = phiFluid[i];

     //set the turbulence into the adsorption model
    compressible::turbulenceModel& turb = turbulence[i];
    reaction.setTurbulence(turb);
    volScalarField& K = KFluid[i];
    volScalarField& dpdt = dpdtFluid[i];

    volScalarField& p = thermo.p();
    const volScalarField& T = thermo.T();
    const volScalarField& psi = thermo.psi();

    volScalarField& p_rgh = p_rghFluid[i];
    const volScalarField& gh = ghFluid[i];
    const surfaceScalarField& ghf = ghfFluid[i];

    multivariateSurfaceInterpolationScheme<scalar>::fieldTable fields;

    forAll(Y, j)
    {
        fields.add(Y[j]);
    }
    fields.add(thermo.he());

    volScalarField dQ
    (
        IOobject
        (
            "dQ",
            runTime.timeName(),
            mesh
        ),
        mesh,
        dimensionedScalar
        (
            "dQ", 
            dimEnergy/dimTime, 
            0.0
        )
    );

    radiation::radiationModel& rad = radiation[i];

    fv::IOoptionList& fvOptions = fluidFvOptions[i];

    const dimensionedScalar initialMass
    (
        "initialMass",
        dimMass,
        initialMassFluid[i]
    );

    //adsorption fields
    volScalarField& adsorptionHeat = adsorptionHeatFluid[i];
    volScalarField& enthalpySource = enthalpySourceFluid[i];
    PtrList<volScalarField>& adsorptions = adsorptionsFluid[i];
    PtrList<volScalarField>& eqAdsorptions = eqAdsorptionsFluid[i];
    PtrList<volScalarField>& volAdsorptions = volAdsorptionsFluid[i];
    PtrList<volScalarField>& surfAdsorptions = surfAdsorptionsFluid[i];
    
