if (finalIter)
{
    mesh.data::add("finalIteration", true);
}

#include "solidHeatSourceTerm.H"

{
    for (int nonOrth=0; nonOrth<=nNonOrthCorr; nonOrth++)
    {
        tmp<fvScalarMatrix> hEqn
        (
            fvm::ddt(betav*rho, h)
          - (
               thermo.isotropic()
             ? fvm::laplacian(betav*thermo.alpha(), h, "laplacian(alpha,h)")
             : fvm::laplacian(betav*tAnialpha(), h, "laplacian(alpha,h)")
            )
          ==
            adsorptionHeat
          + fvOptions(rho, h)
        );

        hEqn().relax();

        fvOptions.constrain(hEqn());

        hEqn().solve(mesh.solver(h.select(finalIter)));

        fvOptions.correct(h);
    }
}

thermo.correct();

Info<< "Min/max T:" << min(thermo.T()).value() << "/" << max(thermo.T()).value() << endl;

if (finalIter)
{
    mesh.data::remove("finalIteration");
}
